package main

import (
	"strings"
)

var mapping = []string{"果德瑪", "喬答摩", "苟答馬", "喬答摩", "維巴西", "毗婆尸", "西奇", "尸棄", "韋沙菩", "毗舍浮", "咖古三塔", "拘留孫", "果那嘎馬那", "拘那含牟尼", "咖沙巴", "迦葉", "美德亞", "彌勒", "比庫", "比丘", "沙利子", "舍利弗", "馬哈摩嘎喇那", "摩訶目犍連", "摩嘎喇那", "目犍連", "馬哈咖沙巴", "大迦葉", "馬哈迦葉", "大迦葉", "伍巴離", "優婆離", "拉胡喇", "羅睺羅", "馬哈咖吒那", "摩訶迦旃延", "馬哈咖吒亞那", "摩訶迦旃延", "咖吒那", "迦旃延", "本那.滿答尼補答", "富樓那", "滿答尼補答", "滿慈子", "本那瓦達那", "富樓那瓦達那", "本那", "富樓那", "滿答尼子", "滿慈子", "馬哈果提答", "摩訶拘絺羅", "馬哈咖比那", "摩訶劫賓那", "咖比那", "劫賓那", "阿奴盧塔", "阿那律", "難達", "難陀", "拔古喇", "薄拘羅", "蘇菩帝", "須菩提", "安雅袞丹雅", "阿若憍陳如", "袞丹雅", "憍陳如", "阿沙基", "阿說示", "畢陵達瓦差", "畢陵伽婆蹉", "嘎旺巴帝", "憍梵波提", "勒瓦答", "離婆多", "雷瓦塔", "離婆多", "雷瓦達", "離越哆", "達拔馬喇子", "遝婆摩羅子", "賓兜喇跋拉度阿迦", "賓頭盧頗羅墮", "朱臘般他嘎", "周利槃陀伽", "咖嚕達夷", "迦留陀夷", "亞沙", "耶舍", "金比喇", "金毘羅", "准達", "純陀", "蘇跋達", "須跋陀羅", "迭瓦達答", "提婆達多", "得瓦達答", "提婆達多", "伍達夷", "優陀夷", "伍巴難達", "跋難陀", "闡那", "車匿", "馬興德", "摩哂陀", "瑪欣德", "摩哂陀", "拔希亞", "婆醯迦", "汪積撒", "婆耆舍", "比庫尼", "比丘尼", "巴迦巴帝苟答彌", "波闍波提瞿曇彌", "巴迦巴帝", "波闍波提", "苟答彌", "瞿曇彌", "亞壽塔拉", "耶輸陀羅", "柯瑪", "差摩", "土喇難達", "偷蘭難陀", "桑喀蜜妲", "僧伽蜜多", "積撒苟答彌", "翅舍喬答彌", "積撒.苟答彌", "翅舍.喬答彌", "積撒‧苟答彌", "翅舍‧喬答彌", "索那", "輸那", "巴答吒拉", "波羅遮那", "旃達羅", "旃檀那", "烏答拉", "鬱多羅", "維末羅", "毘摩羅", "伊西達西", "伊師達悉", "達瑪帝那", "曇摩提那", "昆達拉克薩", "軍陀羅拘夷薩", "吉答", "質多羅", "伍嘎", "郁伽", "基瓦咖", "耆婆", "維沙卡", "毘舍佉", "威沙咖", "毘舍佉", "瑪莉咖", "末利", "庫竹答拉", "久壽多羅", "伍答拉難答母", "鬱多羅難陀母", "沙瑪瓦帝", "差摩婆帝", "面達咖", "面托迦", "摳沙伽", "瞿沙伽", "安巴拔利", "菴婆波利", "庵婆波利", "菴婆波利", "西利瑪", "師利摩", "沙拉瓦提", "娑羅跋提", "薩喇瓦帝", "娑羅跋提", "呵塔卡", "呵多", "賓比薩拉", "頻婆娑羅", "巴謝那地", "波斯匿", "伍達亞那", "優填王", "阿迦答沙都", "阿闍世", "馬哈那馬", "摩訶男", "維都噠跋", "毗琉璃", "阿首咖", "阿育王", "彌林達", "彌蘭陀", "馬嘎塔", "摩揭陀", "高沙喇", "憍薩羅", "瓦基", "跋耆", "咖西", "迦尸", "馬喇", "末羅", "馬拉", "末羅", "盎嘎", "鴦伽", "古盧", "俱盧", "甘塔拉", "犍陀羅", "跋嘎", "婆伽", "沙瓦提", "舍衛", "韋沙離", "毗舍離", "巴拉納西", "波羅奈", "高賞比", "憍賞彌", "巴嗒厘子", "波吒釐子", "咖畢喇瓦土", "迦毗羅衛", "倫比尼", "藍毗尼", "布德嘎亞", "菩提伽耶", "古西那拉", "拘尸那羅", "庫希那拉", "拘尸那羅", "伍盧韋喇", "優樓頻螺", "桑咖沙", "僧伽施", "答咖西喇", "呾叉始羅", "揭達林", "祇園", "揭達", "祇陀", "阿拉維", "阿羅毘", "巴帝摩卡", "波羅提木叉", "伍波薩他", "布薩", "巴拉基嘎", "波羅夷", "桑喀地謝沙", "僧殘", "僧始終", "僧殘", "尼薩耆亞巴吉帝亞", "尼薩耆波逸提", "捨心墮", "尼薩耆波逸提", "巴吉帝亞", "波逸提", "心墮", "波逸提", "土喇吒亞", "偷蘭遮", "甘馬", "羯磨", "馬那答", "摩那埵", "沙馬內拉", "沙彌", "沙馬內莉", "沙彌尼", "桑喀帝", "僧伽梨", "咖提那", "迦絺那", "阿拉漢", "阿羅漢", "巴拉密", "波羅蜜", "維巴沙那", "毘鉢舍那", "阿吒利亞", "阿闍梨", "都西答", "兜率", "三十三天", "忉利天", "亞馬", "夜摩", "沙咖天帝", "帝釋天", "韋沙瓦納", "毗沙門", "甘塔拔", "乾闥婆", "亞卡", "夜叉", "嘎盧臘", "迦樓羅", "那摩", "南無", "阿蘇羅", "阿修羅", "薩度", "善哉", "瓦薩", "僧臘", "孤邸", "茅篷", "在學尼", "式叉摩那", "近事男", "優婆塞", "烏帕薩咖", "優婆塞", "近事女", "優婆夷", "獨覺", "辟支佛", "林野", "阿蘭若", "遮答", "祇陀", "沙利補答", "舍利弗", "巴斯那地", "波斯匿", "孫達利咖拔拉多瓦奢", "孫陀利迦．婆羅墮闍", "孫達利咖", "孫陀利迦", "牟利帕谷那", "牟犁破群那", "韋得希咖", "鞞陀提", "阿利他", "阿梨吒", "毘漏梯咖", "卑盧．婆蹉延那", "難提雅", "難提", "須奇提訶", "善毘提訶", "奇提訶", "毘提訶", "薩遮咖", "薩遮", "沙帝", "[口*荼]帝", "舒芭達", "須跋陀羅", "凱瑪", "差摩", "僧伽. 米塔", "僧伽蜜多", "瑪印達", "摩哂陀", "帕扎佳拉", "波羅遮那", "巴答珈", "波羅遮那", "玻大昆大拉給沙", "軍陀羅拘夷薩", "跋陀軍陀羅拘夷國", "軍陀羅拘夷薩", "吧古喇", "薄拘羅", "普庫沙提", "弗加沙", "沙馬内拉", "沙彌", "巴支咖佛", "辟支佛", "沙拉", "娑羅", "阿難達", "阿難", "帕瓦", "波婆城", "索答般那", "須陀洹", "薩咖達嘎彌", "斯陀含", "阿那嘎彌", "阿那含", "堪塔咖", "犍度", "蘇跋", "須跋", "威跋拉", "南山", "威沙堪馬", "毘舍羯磨", "維那亞", "毘奈耶", "韋碟哈牟尼", "毘提訶牟尼", "咖拉麻", "迦羅摩", "卡拉瑪", "迦羅摩", "葛拉嘛", "迦羅摩", "迦摩羅", "迦羅摩", "葛拉瑪", "迦羅摩", "迦藍磨", "迦羅摩", "卡拉摩", "迦羅摩", "羯臘摩", "迦羅摩", "果德玛", "乔答摩", "苟答马", "乔答摩", "维巴西", "毗婆尸", "西奇", "尸弃", "韦沙菩", "毗舍浮", "咖古三塔", "拘留孙", "果那嘎马那", "拘那含牟尼", "咖沙巴", "迦叶", "美德亚", "弥勒", "比库", "比丘", "沙利子", "舍利弗", "马哈摩嘎喇那", "摩诃目犍连", "摩嘎喇那", "目犍连", "马哈咖沙巴", "大迦叶", "马哈迦叶", "大迦叶", "伍巴离", "优婆离", "拉胡喇", "罗睺罗", "马哈咖吒那", "摩诃迦旃延", "马哈咖吒亚那", "摩诃迦旃延", "咖吒那", "迦旃延", "本那.满答尼补答", "富楼那", "满答尼补答", "满慈子", "本那瓦达那", "富楼那瓦达那", "本那", "富楼那", "满答尼子", "满慈子", "马哈果提答", "摩诃拘絺罗", "马哈咖比那", "摩诃劫宾那", "咖比那", "劫宾那", "阿奴卢塔", "阿那律", "难达", "难陀", "拔古喇", "薄拘罗", "苏菩帝", "须菩提", "安雅衮丹雅", "阿若憍陈如", "衮丹雅", "憍陈如", "阿沙基", "阿说示", "毕陵达瓦差", "毕陵伽婆蹉", "嘎旺巴帝", "憍梵波提", "勒瓦答", "离婆多", "雷瓦塔", "离婆多", "雷瓦达", "离越哆", "达拔马喇子", "遝婆摩罗子", "宾兜喇跋拉度阿迦", "宾头卢颇罗堕", "朱腊般他嘎", "周利盘陀伽", "咖噜达夷", "迦留陀夷", "亚沙", "耶舍", "金比喇", "金毗罗", "准达", "纯陀", "苏跋达", "须跋陀罗", "迭瓦达答", "提婆达多", "得瓦达答", "提婆达多", "伍达夷", "优陀夷", "伍巴难达", "跋难陀", "阐那", "车匿", "马兴德", "摩哂陀", "玛欣德", "摩哂陀", "拔希亚", "婆醯迦", "汪积撒", "婆耆舍", "比库尼", "比丘尼", "巴迦巴帝苟答弥", "波闍波提瞿昙弥", "巴迦巴帝", "波闍波提", "苟答弥", "瞿昙弥", "亚寿塔拉", "耶输陀罗", "柯玛", "差摩", "土喇难达", "偷兰难陀", "桑喀蜜妲", "僧伽蜜多", "积撒苟答弥", "翅舍乔答弥", "积撒.苟答弥", "翅舍.乔答弥", "积撒‧苟答弥", "翅舍‧乔答弥", "索那", "输那", "巴答吒拉", "波罗遮那", "旃达罗", "旃檀那", "乌答拉", "郁多罗", "维末罗", "毗摩罗", "伊西达西", "伊师达悉", "达玛帝那", "昙摩提那", "昆达拉克萨", "军陀罗拘夷萨", "吉答", "质多罗", "伍嘎", "郁伽", "基瓦咖", "耆婆", "维沙卡", "毗舍佉", "威沙咖", "毗舍佉", "玛莉咖", "末利", "库竹答拉", "久寿多罗", "伍答拉难答母", "郁多罗难陀母", "沙玛瓦帝", "差摩婆帝", "面达咖", "面托迦", "抠沙伽", "瞿沙伽", "安巴拔利", "庵婆波利", "庵婆波利", "庵婆波利", "西利玛", "师利摩", "沙拉瓦提", "娑罗跋提", "萨喇瓦帝", "娑罗跋提", "呵塔卡", "呵多", "宾比萨拉", "频婆娑罗", "巴谢那地", "波斯匿", "伍达亚那", "优填王", "阿迦答沙都", "阿闍世", "马哈那马", "摩诃男", "维都哒跋", "毗琉璃", "阿首咖", "阿育王", "弥林达", "弥兰陀", "马嘎塔", "摩揭陀", "高沙喇", "憍萨罗", "瓦基", "跋耆", "咖西", "迦尸", "马喇", "末罗", "马拉", "末罗", "盎嘎", "鸯伽", "古卢", "俱卢", "甘塔拉", "犍陀罗", "跋嘎", "婆伽", "沙瓦提", "舍卫", "韦沙离", "毗舍离", "巴拉纳西", "波罗奈", "高赏比", "憍赏弥", "巴嗒厘子", "波吒厘子", "咖毕喇瓦土", "迦毗罗卫", "伦比尼", "蓝毗尼", "布德嘎亚", "菩提伽耶", "古西那拉", "拘尸那罗", "库希那拉", "拘尸那罗", "伍卢韦喇", "优楼频螺", "桑咖沙", "僧伽施", "答咖西喇", "呾叉始罗", "揭达林", "只园", "揭达", "只陀", "阿拉维", "阿罗毗", "巴帝摩卡", "波罗提木叉", "伍波萨他", "布萨", "巴拉基嘎", "波罗夷", "桑喀地谢沙", "僧残", "僧始终", "僧残", "尼萨耆亚巴吉帝亚", "尼萨耆波逸提", "舍心堕", "尼萨耆波逸提", "巴吉帝亚", "波逸提", "心堕", "波逸提", "土喇吒亚", "偷兰遮", "甘马", "羯磨", "马那答", "摩那埵", "沙马内拉", "沙弥", "沙马内莉", "沙弥尼", "桑喀帝", "僧伽梨", "咖提那", "迦絺那", "阿拉汉", "阿罗汉", "巴拉密", "波罗蜜", "维巴沙那", "毗钵舍那", "阿吒利亚", "阿闍梨", "都西答", "兜率", "三十三天", "忉利天", "亚马", "夜摩", "沙咖天帝", "帝释天", "韦沙瓦纳", "毗沙门", "甘塔拔", "干闼婆", "亚卡", "夜叉", "嘎卢腊", "迦楼罗", "那摩", "南无", "阿苏罗", "阿修罗", "萨度", "善哉", "瓦萨", "僧腊", "孤邸", "茅篷", "在学尼", "式叉摩那", "近事男", "优婆塞", "乌帕萨咖", "优婆塞", "近事女", "优婆夷", "独觉", "辟支佛", "林野", "阿兰若", "遮答", "只陀", "沙利补答", "舍利弗", "巴斯那地", "波斯匿", "孙达利咖拔拉多瓦奢", "孙陀利迦．婆罗堕闍", "孙达利咖", "孙陀利迦", "牟利帕谷那", "牟犁破群那", "韦得希咖", "鞞陀提", "阿利他", "阿梨吒", "毗漏梯咖", "卑卢．婆蹉延那", "难提雅", "难提", "须奇提诃", "善毗提诃", "奇提诃", "毗提诃", "萨遮咖", "萨遮", "沙帝", "[口*荼]帝", "舒芭达", "须跋陀罗", "凯玛", "差摩", "僧伽. 米塔", "僧伽蜜多", "玛印达", "摩哂陀", "帕扎佳拉", "波罗遮那", "巴答珈", "波罗遮那", "玻大昆大拉给沙", "军陀罗拘夷萨", "跋陀军陀罗拘夷国", "军陀罗拘夷萨", "吧古喇", "薄拘罗", "普库沙提", "弗加沙", "沙马内拉", "沙弥", "巴支咖佛", "辟支佛", "沙拉", "娑罗", "阿难达", "阿难", "帕瓦", "波婆城", "索答般那", "须陀洹", "萨咖达嘎弥", "斯陀含", "阿那嘎弥", "阿那含", "堪塔咖", "犍度", "苏跋", "须跋", "威跋拉", "南山", "威沙堪马", "毗舍羯磨", "维那亚", "毗奈耶", "韦碟哈牟尼", "毗提诃牟尼", "咖拉麻", "迦罗摩", "卡拉玛", "迦罗摩", "葛拉嘛", "迦罗摩", "迦摩罗", "迦罗摩", "葛拉玛", "迦罗摩", "迦蓝磨", "迦罗摩", "卡拉摩", "迦罗摩", "羯腊摩", "迦罗摩"}

var r = strings.NewReplacer(mapping...)
